%Jun 11 2010
%Chih-Yuan Yang EECS UC Merced
%need to convert this function to C, otherwise, Matlab runs it too slow
function HBk = Convolute(H, Bk_GauVar )     %too slow, need to transfer this to C
    Sigma = sqrt( Bk_GauVar );
    [height width] = size( H );
    HBk = zeros( height, width);
    for i = 1:height
        for j = 1:width
            YCoor = (i-0.5);
            XCoor = (j-0.5);
            EffectiveRadius = Sigma * 4;
            MostLeftTopSourcePoint.X = XCoor - EffectiveRadius;
            MostLeftTopSourcePoint.Y = YCoor - EffectiveRadius;
            MostRightBottomSourcePoint.X = XCoor + EffectiveRadius;
            MostRightBottomSourcePoint.Y = YCoor + EffectiveRadius;
            %trim
            if MostLeftTopSourcePoint.X < 0.5
                MostLeftTopSourcePoint.X = 0.5;
            end
            if MostLeftTopSourcePoint.Y < 0.5
                MostLeftTopSourcePoint.Y = 0.5;
            end
            if MostRightBottomSourcePoint.X > width - 0.5
                MostRightBottomSourcePoint.X = width - 0.5;
            end
            if MostRightBottomSourcePoint.Y > height - 0.5
                MostRightBottomSourcePoint.Y = height - 0.5;
            end
            
            %Convert Coordinate to grid index
            MostLeftTopSourcePoint.ColIdx = floor(MostLeftTopSourcePoint.X + 0.5);
            MostLeftTopSourcePoint.RowIdx = floor(MostLeftTopSourcePoint.Y + 0.5);
            MostRightBottomSourcePoint.ColIdx = floor(MostRightBottomSourcePoint.X + 0.5);
            MostRightBottomSourcePoint.RowIdx = floor(MostRightBottomSourcePoint.Y + 0.5);
            
            WeightSum = 0;
            IntensitySum = 0;
            for r = MostLeftTopSourcePoint.RowIdx:MostRightBottomSourcePoint.RowIdx
                for c = MostLeftTopSourcePoint.ColIdx:MostRightBottomSourcePoint.ColIdx
                    SrcY = r - 0.5;
                    SrcX = c - 0.5;
                    distSqr = (SrcY - YCoor)^2 + (SrcX - XCoor)^2;
                    if( distSqr < Bk_GauVar * 16);
                        weight = exp(-distSqr/(2*Bk_GauVar))/(2*pi*Bk_GauVar);
                        WeightSum = WeightSum + weight;
                        IntensitySum = IntensitySum + weight * H(r , c );
                    end
                end
            end
            HBk(i,j) = IntensitySum / WeightSum ;
        end
    end
end