%Chih-Yuan Yang, EECS, UC Merced
%File Created: 5 Jul 2010
%Last Modified: 22 Sep 2010
%Use new implementation to run the whole set, see the result
clc
clear
Para.SettingNum = 16;   %Increase Overlap to full (4) to avoid block result. (Also, reduce nn)
Para.MainFolder = ['TempData\BSD300\Setting' num2str(Para.SettingNum) '\'];
Para.RunAnn = true;
Para.B_GauVar = 1.0;            %Smaller GauVar offer more detail in enlarged image
Para.nn = 2;                    %Lower nn, there will be less patches to be averaged. But the affect is very weak.
Para.SSD_Sigma = 25;            %small SSD_Sigma, stronger weight on similar patches. Higher SSD_Sigma, the generated patch tends to average
Para.Zooming = 3;
Para.BuildLayerNum = 5;         %to get 3 times larger, set 5. to get 4 times larger, set 7
Para.BackProjectionLoopNum = 3; %Turn it on(>0). 0: blurred, 1: slightly blurred, 3: sharper than 1, 6: no difference from 3
Para.ReconPixelOverlap = 4;     %0: noisy looks like texture, 1: smoother than 0, 2:more 4: similar to 2, changes little. suggest 2
Para.IdxStart = 201;
Para.IdxEnd = 300;
Para.DbgPrintOutBeforeBackProjectionImage = false;
Para.DbgPrintOutSubLayers = false;
Para.bProduceEachLayerImage = false;
Para.ImageOutputFolder = ['TempData\BSD300\Setting' num2str(Para.SettingNum) '\'];
%backup file
%Create the tempfolder
if ~exist(Para.MainFolder,'dir')
    mkdir(Para.MainFolder);
end
CopyString = ['copy ' mfilename '.m ' Para.MainFolder];
dos(CopyString);

%read file list
FileList = dlmread('Source\BSDS300\FileList.txt');

for i=Para.IdxStart:Para.IdxEnd
    Para.SaveName = num2str(FileList(i));
    Para.TempDataFolder = ['TempData\BSD300\Setting' num2str(Para.SettingNum) '\Temp\' Para.SaveName '\'];
    if ~exist(Para.TempDataFolder,'dir')
        mkdir(Para.TempDataFolder);
    end
    Para.SourceFile = ['Source\BSDS300\' Para.SaveName '.jpg'];
    
    ReadData = double(imread( Para.SourceFile ));
    %Downsample the image to 1/3, avoid remaining boundary
    [h w d] = size( ReadData );
    h1 = h - rem(h,3);
    w1 = w - rem(w,3);
    UsedData = ReadData(1:h1,1:w1,:);
    tempYIQ = RGB2YIQ(UsedData);
    clear ReadData
    GauVarFor3Time = Para.B_GauVar * log(3)/(6*log(1.25));
    ConvY = Convolute(tempYIQ(:,:,1), GauVarFor3Time);
    ConvI = Convolute(tempYIQ(:,:,2), GauVarFor3Time);
    ConvQ = Convolute(tempYIQ(:,:,3), GauVarFor3Time);
    tempYIQ(:,:,1) = ConvY;
    tempYIQ(:,:,2) = ConvI;
    tempYIQ(:,:,3) = ConvQ;
    DownSizeYIQ = imresize(tempYIQ, 1/3);   %bilinear or linear no difference
    DownSizeImage = YIQ2RGB(DownSizeYIQ);
    InputImage = uint8(DownSizeImage);
    imwrite( InputImage , [Para.ImageOutputFolder Para.SaveName '_input.png']);
    
    ChannelNumber = size( InputImage , 3);
    if ChannelNumber == 3
        img_yiq = RGB2YIQ(double(InputImage));
        img_y = img_yiq(:,:,1);
        IQLayer = img_yiq(:,:,2:3);
    elseif ChannnelNumber == 1
        img_y = double(InputImage);
    end

    MainProcedure2 
end