%Chih-Yuan Yang, EECS, UC Merced
%File Created: 1 Nov 2010
%Last Modified: 1 Nov 2010
%Build the Zebra image for discriminative super resolution (CVPR 2010)

clc
clear
Para.SettingNum = 1;
Para.RunAnn = true;
Para.B_GauVar = 1.0;
Para.nn = 1;
Para.SSD_Sigma = 25;
Para.Zooming = 3;
Para.SaveName = 'Zebra';
Para.SourceFile = 'Source\Zebra_input.png';
Para.SourceAsLowResInput = true;
Para.TempDataFolder = ['TempData\' Para.SaveName '\Setting' num2str(Para.SettingNum) '\'];
Para.MainFolder = Para.TempDataFolder;
Para.BuildLayerNum = 5;     %to get 3 times larger, set 5. to get 4 times larger, set 7
Para.BackProjectionLoopNum = 3;
Para.ReconPixelOverlap = 4;
Para.DbgPrintOutBeforeBackProjectionImage = false;
Para.DbgPrintOutSubLayers = false;
Para.bProduceEachLayerImage = false;
Para.ImageOutputFolder = Para.TempDataFolder;
%backup file
%Create the tempfolder
if ~exist(Para.MainFolder,'dir')
    mkdir(Para.MainFolder);
end
CopyString = ['copy ' mfilename '.m ' Para.MainFolder];
dos(CopyString);


ReadData = double(imread( Para.SourceFile ));
%Downsample the image to 1/3, avoid remaining boundary
if Para.SourceAsLowResInput == false
    [h w d] = size( ReadData );
    h1 = h - rem(h,3);
    w1 = w - rem(w,3);
    UsedData = ReadData(1:h1,1:w1,:);
    tempYIQ = RGB2YIQ(UsedData);
    clear ReadData
    GauVarFor3Time = Para.B_GauVar * log(3)/(6*log(1.25));
    ConvY = Convolute(tempYIQ(:,:,1), GauVarFor3Time);
    ConvI = Convolute(tempYIQ(:,:,2), GauVarFor3Time);
    ConvQ = Convolute(tempYIQ(:,:,3), GauVarFor3Time);
    tempYIQ(:,:,1) = ConvY;
    tempYIQ(:,:,2) = ConvI;
    tempYIQ(:,:,3) = ConvQ;
    DownSizeYIQ = imresize(tempYIQ, 1/3);   %bilinear or linear no difference
    DownSizeImage = YIQ2RGB(DownSizeYIQ);
else
    DownSizeImage = ReadData;
end
InputImage = uint8(DownSizeImage);
imwrite( InputImage , [Para.ImageOutputFolder Para.SaveName '_input.png']);

ChannelNumber = size( InputImage , 3);
if ChannelNumber == 3
    img_yiq = RGB2YIQ(double(InputImage));
    img_y = img_yiq(:,:,1);
    IQLayer = img_yiq(:,:,2:3);
elseif ChannnelNumber == 1
    img_y = double(InputImage);
end

MainProcedure2 
