%Create Initial Dictionary, initialDictionary from the Singla, but not
%repeat
%Feb 16 2010
%Chih-Yuan Yang
function CreateInitialDictionary( Para )
    TempFolder = Para.TempDataFolder;
    SaveName = Para.SaveName;
    
    LoadData = load([TempFolder SaveName '_XlXh.mat']);
    XlXh = LoadData.XlXh;
    clear LoadData;

    SqrtSumOfSquare = sqrt(sum(XlXh.^2));
    
    [Dim DataSize] = size(XlXh);
    codesize = Para.DictionarySize;
    InitialDictionary = zeros(Dim , codesize );
    Thd = 1e-5;
    idx = 0;
    for i=1:DataSize
        if SqrtSumOfSquare(i) >= Thd      %not use pure zero
            CandidateSignal = XlXh(:,i);
        
            %verify non-repeated
            bRepeated = false;
            for j=1:idx
                ComparedSignal = InitialDictionary(:,j);
                SignalDiff = ComparedSignal - CandidateSignal;
                SumAbs = sum(abs(SignalDiff));
                if SumAbs < Thd
                    bRepeated = true;
                    break;
                end
            end

            if bRepeated == false
                idx = idx + 1;
                InitialDictionary(:,idx) = CandidateSignal;       %I don't use randperm for observation
                if idx == codesize
                    break;
                end
            end
        end
    end
    DlDh = InitialDictionary;
    save([TempFolder SaveName '_DlDh0.mat'], 'DlDh');
end