%Get image pairs from Irani's image pyramid, do group sparse representation
%Feb 2 2010
%Chih-Yuan Yang
function SaveInfo( Para , CurrentFileName )
    %write to file
    if ~exist(Para.TempDataFolder,'dir')
        mkdir(Para.TempDataFolder);
    end
    fid = fopen( [Para.TempDataFolder Para.SaveName '_Setting' num2str(Para.SettingNum) '_Info.txt' ], 'a');
    fprintf( fid , '\n' );  %create an empty line
    infostr = ['run start time = ' datestr(now)];
    fprintf( fid , '%s\n' ,infostr);
    [NotUsed HostName] = system('hostname');
    infostr = ['Hostname = ' HostName];
    fprintf( fid , '%s' ,infostr);
    
    names = fieldnames( Para );
    for i = 1:length(names)
        SaveField( fid, Para , names{i});
    end
    fclose(fid);
    
    %make a copy to temp folder
    CopyString = ['copy ' CurrentFileName '.m ' Para.TempDataFolder 'Main_' Para.SaveName '_Setting' num2str(Para.SettingNum) '_Backup.m ' ];
    dos(CopyString);
end

function SaveField( fid , Para, FieldName )
    if isfield( Para , FieldName )
        Field = getfield( Para , FieldName );
        if isa(Field , 'double')
            savestring = num2str( Field );
        end
        if isa( Field , 'char' )
            savestring = Field;
        end
        if isa( Field , 'logical' )
            if Field == true
                savestring = 'true';
            else
                savestring = 'false';
            end
        end
        infostr = [FieldName ' = ' savestring];
        fprintf( fid , '%s\n' ,infostr);
    end
end